=== debian/changelog ===
cbmc (5.84.0-6) unstable; urgency=low

  * Fix further portability problems (Closes: #1038866)

 -- Michael Tautschnig <mt@debian.org>  Sun, 25 Jun 2023 20:14:35 +0100

cbmc (5.84.0-5) unstable; urgency=low

  * Fix further portability problems

 -- Michael Tautschnig <mt@debian.org>  Fri, 16 Jun 2023 21:58:47 +0100

cbmc (5.84.0-4) unstable; urgency=low

  * Fix portability problems

 -- Michael Tautschnig <mt@debian.org>  Tue, 13 Jun 2023 21:27:48 +0100

cbmc (5.84.0-3) unstable; urgency=low

  * Fix several lintian warnings
  * Introduce new jbmc binary package

 -- Michael Tautschnig <mt@debian.org>  Mon, 05 Jun 2023 20:18:58 +0100

cbmc (5.84.0-2) unstable; urgency=low

  * Fix several portability issues.
  * Added autopkgtest

 -- Michael Tautschnig <mt@debian.org>  Sat, 03 Jun 2023 21:07:29 +0100

cbmc (5.84.0-1) unstable; urgency=low

  * New upstream release
  * Includes bugfix for unintentional copy (Closes: #984008)
  * Updated Standards version to 4.6.0 (no changes required)

 -- Michael Tautschnig <mt@debian.org>  Wed, 31 May 2023 08:18:04 +0100
