=== debian/tests/control ===
Tests: failing-assert1
Depends: gcc, libc6-dev
